/***
 * Speaks IRC
 */



package wtalk.protocols.rfc1459;

import java.net.*;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.Vector;

public class IRCProtocol{
	private PrintWriter out= null;

	public IRCProtocol(Socket sock){ 
		try{
		out = new PrintWriter(sock.getOutputStream(), true);
		}catch(java.io.IOException e){}
	}

	public void Connect(String sServer, int iPort, 
			String sPassword, String sNickname ) {
		IRCMessage messagePass = new IRCMessage(), 
			messageUser = new IRCMessage();

		messagePass.setCommand("PASS");
		messagePass.addParam(sPassword);
		messagePass.send(out);

		setNick(sNickname);

		messageUser.setCommand("USER");
		messageUser.addParam(sNickname);
		messageUser.addParam(sServer);	//should be hostname :(
		messageUser.addParam(sServer);
		messageUser.addParam(":DMC User");
		messageUser.send(out);
	}

	public void SendMessage(String Message) {
		IRCMessage ircMessage = new IRCMessage(Message);
		ircMessage.send(out);
	}

	public void SendMessage(String Command, Vector Params) {
		IRCMessage ircMessage = new IRCMessage();
		ircMessage.setCommand(Command);

		for(int i=0; i<Params.size(); ++i)
			ircMessage.addParam((String)Params.get(i));

	}

	// 4.1.2
	public void setNick(String sNickname) {
		IRCMessage messageNick = new IRCMessage(); 
		messageNick.setCommand("NICK"); 
		messageNick.addParam(sNickname); 
		messageNick.send(out);
	}

	// 4.1.6
	public void sendQuit(String sQuitMessage) {
		IRCMessage message = new IRCMessage();
		message.setCommand("QUIT");
		if(sQuitMessage!=null && sQuitMessage.length() > 0)
			message.addParam(":" + sQuitMessage);
		message.send(out);
		//System.err.println("Quit with message: " + sQuitMessage);
		//System.err.println(message);
	}

	// 4.2.1
	// This currently doesn't support 'keys' [passwords]
	public void sendJoin(String sRoom) {
		IRCMessage message = new IRCMessage();
		message.setCommand("JOIN");
		message.addParam(sRoom);
		message.send(out);
	}

	// 4.2.2
	public void sendPart(String sRoom) {
		IRCMessage message = new IRCMessage();
		message.setCommand("PART");
		message.addParam(sRoom);
		message.send(out);
	}

	// 4.2.4
	public void sendTopic(String sRoom, String sTopic) {
		IRCMessage message = new IRCMessage();
		message.setCommand("TOPIC");
		message.addParam(sRoom);
		if(sTopic!=null) 
			message.addParam(":"+sTopic);
		message.send(out);
	}

	// 4.2.6
	public void sendList(String sRoom) {
		IRCMessage message = new IRCMessage();
		message.setCommand("LIST"); 
		if(sRoom!=null && sRoom.length() > 0)
			message.addParam(sRoom);
		message.send(out);
	}

	// 4.4.1
	public void sendPrivMsg(String sReceivers, String sText) {
		IRCMessage message=new IRCMessage();
		message.setCommand("PRIVMSG");
		message.addParam(sReceivers);
		message.addParam(":"+sText);
		message.send(out);
	}

	// 4.5.2
	public void sendWhois(String user) {
		IRCMessage message = new IRCMessage();
		message.setCommand("WHOIS");
		message.addParam(user);
		message.send(out);
	}

	// 4.6.3
	public void sendPong(String daemon) { sendPong(daemon, null); }
	public void sendPong(String daemon, String daemon2) {
		IRCMessage message = new IRCMessage();
		message.setCommand("PONG");
		message.addParam(daemon);
		if(daemon2!=null) message.addParam(daemon2);
		message.send(out);
	}
}
