package wtalk.protocols.toc;

import wtalk.RMsgHandler;
import wtalk.protocols.WTalkProtocol;
import wtalk.protocols.toc.jaim.*;

class EventListener implements JaimEventListener {
	protected String mName = null;
	protected RMsgHandler amh = null;
	protected RMsgHandler smh = null;
	protected RMsgHandler dmh = null;
	protected RMsgHandler dmch = null;
	protected UserListMaintainer ulm = null;

	EventListener(String tname, UserListMaintainer tul, RMsgHandler tdmch,
			RMsgHandler tamh, RMsgHandler tsmh, RMsgHandler tdmh) {
		amh = tamh; smh = tsmh; dmh = tdmh;
		mName = tname; ulm = tul; dmch=tdmch;
	}

	public void receiveEvent(JaimEvent ev) {
		String sType = ev.getTocResponse().getResponseType();
		String sMsg = null;
		String sSub= null;

		if(sType.equals(TocDefines.JAIM_LOGIN_COMPLETE)) {
			smh.handle("","","Login Successful!");
			smh.handle("","", mName + " is now registered.");
		}

		if(sType.equals(BuddyUpdateTocResponse.RESPONSE_TYPE)) {
			handleBuddyUpdate((BuddyUpdateTocResponse)
					ev.getTocResponse());
		}

		if(sType.equals(TocDefines.JAIM_IM_IN)) {
			IMTocResponse imtr=(IMTocResponse)(ev.getTocResponse());

			// TODO: Parse out sub code
			sSub = HTMLParser.getComments(imtr.getMsg());
			sMsg = HTMLParser.HTML2ASCII(imtr.getMsg());
			if(sSub!="" && dmch!=null) {
				dmch.handle(mName, imtr.getFrom(), sSub);
				System.err.println("Recieved comment: "+sSub);
			}
			if(sMsg!="") {
				if(amh!=null && imtr.getAutoResponse()) {
					// Handle with auto-handler
					amh.handle(mName, imtr.getFrom(), sMsg);
				} else {
					// Handle with normal message handler
					dmh.handle(mName, imtr.getFrom(), sMsg);
				}
			}
		}

	}

	private void handleBuddyUpdate(BuddyUpdateTocResponse butr) {
		String sStatus = butr.isOnline() ? ((butr.isAway())? "Away"
				: "Online") : "Offline";
		ulm.updateBuddy(butr.getBuddy(), sStatus);
	}
}


